diff --git a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
index ada53f8b5..09b3ca0db 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/DimensionData.java
@@ -1,15 +1,15 @@
 package net.minecraft.core.world.save;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.tags.ByteTag;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
-import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.SettingNodesValues;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.settings.WorldSettingNodes;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
-import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
@@ -30,7 +30,15 @@ public class DimensionData {
             worldType = WorldTypeGroups.DEFAULT.get(dimension);
         }
 
-        final @NotNull DimensionData dimensionData = new DimensionData(worldType);
+        final @NotNull SettingNodesValues dimensionSettings;
+        if (tag.containsKey("DimensionSettings")) {
+            final @NotNull CompoundTag dimensionSettingsTag = tag.getCompound("DimensionSettings");
+            dimensionSettings = SettingNodesValues.deserialize(WorldSettingNodes.getRootNode(), dimension, dimensionSettingsTag);
+        } else {
+            dimensionSettings = new SettingNodesValues(WorldSettingNodes.getRootNode(), dimension);
+        }
+
+        final @NotNull DimensionData dimensionData = new DimensionData(worldType, dimensionSettings);
 
         final @NotNull CompoundTag weatherTag = tag.getCompound("Weather");
         dimensionData.weatherCurrentId = weatherTag.getInteger("CurrentID");
@@ -45,6 +53,10 @@ public class DimensionData {
     public static @NotNull CompoundTag toCompoundTag(final @NotNull DimensionData dimensionData, final @NotNull CompoundTag out) {
         out.putString("WorldType", Objects.requireNonNull(Registries.WORLD_TYPES.getKey(dimensionData.worldType)));
 
+        final @NotNull CompoundTag dimensionSettingsTag = new CompoundTag();
+        SettingNodesValues.serialize(dimensionData.dimensionSettings, dimensionSettingsTag);
+        out.put("DimensionSettings", dimensionSettingsTag);
+
         final @NotNull CompoundTag weatherTag = new CompoundTag();
         weatherTag.putInt("CurrentID", dimensionData.weatherCurrentId);
         weatherTag.putInt("NextID", dimensionData.weatherNextId);
@@ -85,21 +97,35 @@ public class DimensionData {
     }
 
     private final @NotNull WorldType worldType;
+    private final @NotNull SettingNodesValues dimensionSettings;
     private int weatherCurrentId = -1;
     private int weatherNextId = -1;
     private long weatherDuration;
     private float weatherIntensity;
     private float weatherPower;
 
-    public DimensionData(
-        final @NotNull WorldType worldType
+    private DimensionData(
+        final @NotNull WorldType worldType,
+        final @NotNull SettingNodesValues dimensionSettings
     ) {
         this.worldType = worldType;
+        this.dimensionSettings = dimensionSettings;
     }
 
-    public DimensionData(final @NotNull DimensionData dimensionData) {
-        this(dimensionData.worldType);
+    public DimensionData(
+        final @NotNull Dimension dimension,
+        final @NotNull WorldConfiguration worldConfiguration
+    ) {
+        this(
+            worldConfiguration.getWorldTypeGroup().get(dimension),
+            worldConfiguration.getDimensionSettings(dimension)
+        );
+    }
 
+    public DimensionData(final @NotNull DimensionData dimensionData, final @NotNull Dimension dimension) {
+        this.worldType = dimensionData.worldType;
+        this.dimensionSettings = new SettingNodesValues(WorldSettingNodes.getRootNode(), dimension);
+        this.dimensionSettings.setAll(dimensionData.dimensionSettings);
         this.weatherCurrentId = dimensionData.weatherCurrentId;
         this.weatherNextId = dimensionData.weatherNextId;
         this.weatherDuration = dimensionData.weatherDuration;
@@ -111,6 +137,10 @@ public class DimensionData {
         return this.worldType;
     }
 
+    public @NotNull SettingNodesValues getDimensionSettings() {
+        return this.dimensionSettings;
+    }
+
     public @Nullable Weather getCurrentWeather() {
         if (this.weatherCurrentId < 0) {
             return null;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
index b33218d76..76247fd7c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -7,6 +7,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -19,13 +20,13 @@ import java.util.UUID;
 public class LevelData {
     private static final @NotNull Logger LOGGER = LogUtils.getLogger();
 
-    public static @NotNull LevelData fromCompoundTag(final @NotNull CompoundTag tag) {
+    public static @NotNull LevelData deserialize(final @NotNull CompoundTag tag) {
         final long randomSeed = tag.getLong("RandomSeed");
         final @NotNull String levelName = tag.getString("LevelName");
 
         final @NotNull GameRuleCollection gameRules;
         if (tag.containsKey("GameRules")) {
-            final CompoundTag gameRulesTag = tag.getCompound("GameRules");
+            final @NotNull CompoundTag gameRulesTag = tag.getCompound("GameRules");
             gameRules = GameRuleCollection.readFromNBT(gameRulesTag);
         } else {
             gameRules = new GameRuleCollection();
@@ -33,8 +34,8 @@ public class LevelData {
 
         final @NotNull SpawnerConfig spawnerConfig;
         if (tag.containsKey("SpawnConfig")) {
-            final CompoundTag spawnConfigTag = tag.getCompound("SpawnConfig");
-            spawnerConfig = SpawnerConfig.createFromTag(spawnConfigTag);
+            final @NotNull CompoundTag spawnerConfigTag = tag.getCompound("SpawnConfig");
+            spawnerConfig = SpawnerConfig.createFromTag(spawnerConfigTag);
         } else {
             spawnerConfig = new SpawnerConfig();
         }
@@ -70,7 +71,7 @@ public class LevelData {
         return data;
     }
 
-    public static @NotNull CompoundTag toCompoundTag(final @NotNull LevelData levelData, final @NotNull CompoundTag out) {
+    public static @NotNull CompoundTag serialize(final @NotNull LevelData levelData, final @NotNull CompoundTag out) {
         out.putLong("RandomSeed", levelData.randomSeed);
         out.putInt("SpawnX", levelData.spawnPos.x);
         out.putInt("SpawnY", levelData.spawnPos.y);
@@ -84,7 +85,7 @@ public class LevelData {
         out.putInt("Difficulty", levelData.difficulty.id());
         out.putBoolean("DifficultyLock", levelData.difficultyLocked);
 
-        final CompoundTag gameRulesTag = new CompoundTag();
+        final @NotNull CompoundTag gameRulesTag = new CompoundTag();
         GameRuleCollection.writeToNBT(gameRulesTag, levelData.gameRules);
         out.put("GameRules", gameRulesTag);
 
@@ -92,7 +93,7 @@ public class LevelData {
             out.putString("LastPlayerUUID", levelData.lastPlayerUUID.toString());
         }
 
-        final CompoundTag spawnerConfigTag = new CompoundTag();
+        final @NotNull CompoundTag spawnerConfigTag = new CompoundTag();
         levelData.spawnerConfig.writeToTag(spawnerConfigTag);
         out.put("SpawnConfig", spawnerConfigTag);
 
@@ -118,7 +119,7 @@ public class LevelData {
         }
 
         if (nbtRootData != null) {
-            return LevelData.fromCompoundTag(nbtRootData);
+            return LevelData.deserialize(nbtRootData);
         } else {
             throw new IOException();
         }
@@ -166,17 +167,15 @@ public class LevelData {
         );
     }
 
-    public LevelData(
-        final long randomSeed,
-        final @NotNull String name,
-        final @NotNull GameRuleCollection gameRules
-    ) {
+    public LevelData(final @NotNull WorldConfiguration worldConfiguration) {
         this(
-            randomSeed,
-            name,
-            gameRules,
-            new SpawnerConfig()
+            worldConfiguration.getFinalNumericSeed(),
+            worldConfiguration.getFinalWorldName(),
+            worldConfiguration.getGameRules(),
+            worldConfiguration.getSpawnerConfig()
         );
+
+        this.setCheatsEnabled(worldConfiguration.getCheatsEnabled());
     }
 
     public LevelData(final @NotNull LevelData levelData) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
index 672b374c2..69fa2e715 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageBase.java
@@ -123,7 +123,7 @@ public abstract class LevelStorageBase implements LevelStorage
 	@Override
 	public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
 	{
-		CompoundTag dataTag = LevelData.toCompoundTag(levelData, new CompoundTag());
+		CompoundTag dataTag = LevelData.serialize(levelData, new CompoundTag());
 		CompoundTag savedTag = new CompoundTag();
 		savedTag.put("Data", dataTag);
 		try
@@ -166,7 +166,7 @@ public abstract class LevelStorageBase implements LevelStorage
 	@Override
 	public void saveLevelData(@NotNull LevelData levelData)
 	{
-		saveLevelDataRaw(LevelData.toCompoundTag(levelData, new CompoundTag()));
+		saveLevelDataRaw(LevelData.serialize(levelData, new CompoundTag()));
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index 3f8a8fadc..7660a31f3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -38,7 +38,7 @@ public abstract class SaveFormatBase
     {
         CompoundTag tag = getLevelDataRaw(worldDirName);
         if (tag == null) return null;
-        return LevelData.fromCompoundTag(tag);
+        return LevelData.deserialize(tag);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/WorldConfigurationReader.java b/game/core/src/main/java/net/minecraft/core/world/save/WorldConfigurationReader.java
new file mode 100644
index 000000000..3dfa9c8b6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/WorldConfigurationReader.java
@@ -0,0 +1,24 @@
+package net.minecraft.core.world.save;
+
+import net.minecraft.core.data.gamerule.GameRuleCollection;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
+import net.minecraft.core.world.settings.SettingNodesValues;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+
+public interface WorldConfigurationReader {
+    long getFinalNumericSeed();
+
+    @NotNull String getFinalWorldName();
+
+    @NotNull GameRuleCollection getGameRules();
+
+    @NotNull SpawnerConfig getSpawnerConfig();
+
+    boolean getCheatsEnabled();
+
+    @NotNull WorldType getWorldType(final @NotNull Dimension dimension);
+
+    @NotNull SettingNodesValues getDimensionSettings(final @NotNull Dimension dimension);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
index 516e62308..297412ccc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
@@ -3,11 +3,16 @@ package net.minecraft.core.world.save.conversion;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.SaveFormats;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.type.WorldTypeGroups;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 
@@ -71,11 +76,25 @@ public class SaveConverter19133To19134
                 if (worldTypes != null)
                 {
                     int worldType = worldTypes[dim.id];
-                    dimensionData = new DimensionData(LegacyWorldTypes.getWorldTypeById(worldType));
+                    final @NotNull WorldConfiguration worldConfiguration = new WorldConfiguration();
+                    for (final @NotNull WorldTypeGroups.Group group : WorldTypeGroups.GROUPS) {
+                        if (group.get(dim).equals(Registries.WORLD_TYPES.getItemByNumericId(worldType))) {
+                            worldConfiguration.setWorldTypeGroup(group);
+                            break;
+                        }
+                    }
+                    dimensionData = new DimensionData(dim, worldConfiguration);
                 }
                 else
                 {
-                    dimensionData = new DimensionData(dim.defaultWorldType);
+                    final @NotNull WorldConfiguration worldConfiguration = new WorldConfiguration();
+                    for (final @NotNull WorldTypeGroups.Group group : WorldTypeGroups.GROUPS) {
+                        if (group.get(dim).equals(dim.defaultWorldType)) {
+                            worldConfiguration.setWorldTypeGroup(group);
+                            break;
+                        }
+                    }
+                    dimensionData = new DimensionData(dim, worldConfiguration);
                 }
                 toFormat.getLevelStorage(worldDirName, false).saveDimensionData(dim.id, dimensionData);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/season/Season.java b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
index c7cbfc2ba..988048e36 100644
--- a/game/core/src/main/java/net/minecraft/core/world/season/Season.java
+++ b/game/core/src/main/java/net/minecraft/core/world/season/Season.java
@@ -37,9 +37,8 @@ public abstract class Season
 		this.hasDeeperSnow = hasDeeperSnow;
 	}
 
-	public String getId()
-	{
-		return id;
+	public @NotNull String getId() {
+		return this.id;
 	}
 
 	public @NotNull String getLanguageKey() {
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java
index 7f84c0905..b2e94e477 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ContainerSettingNode.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.settings;
 
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 
 public class ContainerSettingNode implements SettingNode {
@@ -10,6 +12,17 @@ public class ContainerSettingNode implements SettingNode {
         this.childrenProvider = childrenProvider;
     }
 
+    @Override
+    public @NotNull SettingNode withChild(final @NotNull SettingNode child) {
+        if (!(this.childrenProvider instanceof final @NotNull ListSettingNodeChildrenProvider childrenProvider)) {
+            throw new RuntimeException("Incorrect child provider to manually add child!");
+        }
+
+        childrenProvider.withChild(child);
+
+        return this;
+    }
+
     public final @NotNull ContainerSettingNode withVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
         this.visibilityListener = visibilityListener;
 
@@ -22,12 +35,12 @@ public class ContainerSettingNode implements SettingNode {
     }
 
     @Override
-    public boolean isVisible(final @NotNull WorldConfiguration worldConfiguration) {
-        return this.visibilityListener.isVisible(worldConfiguration);
+    public boolean isVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.visibilityListener.isVisible(config);
     }
 
     @Override
-    public boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration) {
-        return this.visibilityListener.isVisible(worldConfiguration);
+    public boolean areChildrenVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.visibilityListener.isVisible(config);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java
index 58cabe811..79ff8a9ba 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.settings;
 
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -7,7 +9,6 @@ public abstract class GenericSettingNode implements KeyedSettingNode {
     private final @NotNull String key;
     private @Nullable SettingNodeChildrenProvider childrenProvider = null;
     private @NotNull SettingNodeVisibilityListener selfVisibilityListener = SettingNodeVisibilityListener::alwaysVisible;
-    private @NotNull SettingNodeVisibilityListener childrenVisibilityListener = SettingNodeVisibilityListener::alwaysVisible;
 
     public GenericSettingNode(final @NotNull String key) {
         this.key = key;
@@ -15,6 +16,22 @@ public abstract class GenericSettingNode implements KeyedSettingNode {
         KeyedSettingNode.checkKeyIsUnique(key);
     }
 
+    @Override
+    public @NotNull SettingNode withChild(final @NotNull SettingNode child) {
+        if (this.childrenProvider != null && !(this.childrenProvider instanceof ListSettingNodeChildrenProvider)) {
+            throw new RuntimeException("Incorrect child provider to manually add child!");
+        }
+
+        if (this.childrenProvider == null) {
+            this.childrenProvider = new ListSettingNodeChildrenProvider();
+        }
+
+        final @NotNull ListSettingNodeChildrenProvider childrenProvider = (ListSettingNodeChildrenProvider) this.childrenProvider;
+        childrenProvider.withChild(child);
+
+        return this;
+    }
+
     @Override
     public @NotNull String getKey() {
         return this.key;
@@ -32,8 +49,8 @@ public abstract class GenericSettingNode implements KeyedSettingNode {
     }
 
     @Override
-    public boolean isVisible(final @NotNull WorldConfiguration worldConfiguration) {
-        return this.selfVisibilityListener.isVisible(worldConfiguration);
+    public boolean isVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.selfVisibilityListener.isVisible(config);
     }
 
     public final @NotNull GenericSettingNode withVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
@@ -41,15 +58,4 @@ public abstract class GenericSettingNode implements KeyedSettingNode {
 
         return this;
     }
-
-    @Override
-    public boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration) {
-        return this.isVisible(worldConfiguration) && this.childrenVisibilityListener.isVisible(worldConfiguration);
-    }
-
-    public final @NotNull GenericSettingNode withChildrenVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
-        this.childrenVisibilityListener = visibilityListener;
-
-        return this;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java b/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java
index 77dbd7164..bac434eaa 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java
@@ -15,17 +15,12 @@ public class ListSettingNodeChildrenProvider implements SettingNodeChildrenProvi
     private final @NotNull Map<@NotNull String, @NotNull KeyedSettingNode> keyedChildren = new Object2ObjectOpenHashMap<>();
 
     @Override
-    public int length(final @NotNull WorldConfiguration worldConfiguration) {
+    public int length() {
         return this.children.size();
     }
 
     @Override
-    public @NotNull Iterator<@NotNull SettingNode> getChildren(final @NotNull WorldConfiguration worldConfiguration) {
-        return this.children.iterator();
-    }
-
-    @Override
-    public @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration) {
+    public @Nullable KeyedSettingNode getChildByKey(final @NotNull String key) {
         return this.keyedChildren.get(key);
     }
 
@@ -45,4 +40,9 @@ public class ListSettingNodeChildrenProvider implements SettingNodeChildrenProvi
 
         return this;
     }
+
+    @Override
+    public @NotNull Iterator<@NotNull SettingNode> iterator() {
+        return this.children.iterator();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ListValueSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ListValueSettingNode.java
new file mode 100644
index 000000000..845caf35e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ListValueSettingNode.java
@@ -0,0 +1,16 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.List;
+
+public interface ListValueSettingNode<T> extends ValueSettingNode<T> {
+    @NotNull List<@NotNull T> getValues(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
+
+    @Override
+    default boolean validateValue(final @NotNull T value, final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config) {
+        return this.getValues(dimension, config).contains(value);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java
index 324ae2e89..134fc3899 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java
@@ -1,8 +1,10 @@
 package net.minecraft.core.world.settings;
 
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 
 public interface RangeValueSettingNode<T> extends ValueSettingNode<T> {
-    @NotNull T getMinimum(final @NotNull WorldConfiguration worldConfiguration);
-    @NotNull T getMaximum(final @NotNull WorldConfiguration worldConfiguration);
+    @NotNull T getMinimumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
+    @NotNull T getMaximumValue(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java
index b7811ee47..dd7b435c6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java
@@ -1,28 +1,29 @@
 package net.minecraft.core.world.settings;
 
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Iterator;
-
 public interface SettingNode {
     @Nullable SettingNodeChildrenProvider getChildrenProvider();
 
-    boolean isVisible(final @NotNull WorldConfiguration worldConfiguration);
+    boolean isVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
+
+    boolean areChildrenVisible(final @NotNull Dimension dimension, final @NotNull WorldConfigurationReader config);
 
-    boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration);
+    @NotNull SettingNode withChild(final @NotNull SettingNode child);
 
-    default @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration) {
+    default @Nullable KeyedSettingNode getChildByKey(final @NotNull String key) {
         final @Nullable SettingNodeChildrenProvider childrenProvider = this.getChildrenProvider();
         if (childrenProvider != null) {
-            final @Nullable KeyedSettingNode myChild = childrenProvider.getChildByKey(key, worldConfiguration);
+            final @Nullable KeyedSettingNode myChild = childrenProvider.getChildByKey(key);
             if (myChild != null) {
                 return myChild;
             }
-            
-            for (final @NotNull Iterator<@NotNull SettingNode> it = childrenProvider.getChildren(worldConfiguration); it.hasNext(); ) {
-                final @NotNull SettingNode child = it.next();
-                final @Nullable KeyedSettingNode childsChild = child.getChildByKey(key, worldConfiguration); // recursion here
+
+            for (final @NotNull SettingNode child : childrenProvider) {
+                final @Nullable KeyedSettingNode childsChild = child.getChildByKey(key); // recursion here
                 if (childsChild != null) {
                     return childsChild;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java
index c5794c923..83094c5c0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java
@@ -5,10 +5,8 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Iterator;
 
-public interface SettingNodeChildrenProvider {
-    int length(final @NotNull WorldConfiguration worldConfiguration);
+public interface SettingNodeChildrenProvider extends Iterable<@NotNull SettingNode> {
+    int length();
 
-    @NotNull Iterator<@NotNull SettingNode> getChildren(final @NotNull WorldConfiguration worldConfiguration);
-
-    @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration);
+    @Nullable KeyedSettingNode getChildByKey(final @NotNull String key);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java
index d62f53896..05a6c0820 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java
@@ -1,17 +1,18 @@
 package net.minecraft.core.world.settings;
 
+import net.minecraft.core.world.save.WorldConfigurationReader;
 import org.jetbrains.annotations.NotNull;
 
 public interface SettingNodeVisibilityListener {
-    boolean isVisible(final @NotNull WorldConfiguration worldConfiguration);
+    boolean isVisible(final @NotNull WorldConfigurationReader config);
 
     @SuppressWarnings("unused")
-    static boolean alwaysVisible(final @NotNull WorldConfiguration worldConfiguration) {
+    static boolean alwaysVisible(final @NotNull WorldConfigurationReader config) {
         return true;
     }
 
     @SuppressWarnings("unused")
-    static boolean neverVisible(final @NotNull WorldConfiguration worldConfiguration) {
+    static boolean neverVisible(final @NotNull WorldConfigurationReader config) {
         return false;
     }
 }
